# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from knack.help_files import helps
from azdata.cli.commands.extension import _

helps['extension'] = """
type: group
short-summary: {short}
""".format(short=_('Manage and update CLI extensions.'))

# pylint: disable=line-too-long
helps['extension add'] = """
type: command
short-summary: {short}
examples:
  - name: {ex1}
    text: azdata extension add --source https://contoso.com/some_ext-0.0.1-py2.py3-none-any.whl
  - name: {ex2}
    text: azdata extension add --source ~/some_ext-0.0.1-py2.py3-none-any.whl
  - name: {ex3}
    text: azdata extension add --source ~/some_ext-0.0.1-py2.py3-none-any.whl --pip-proxy https://user:pass@proxy.server:8080
""".format(
    short=_('Add an extension.'),
    ex1=_('Add extension from URL.'),
    ex2=_('Add extension from local disk.'),
    ex3=_('Add extension from local disk and use pip proxy for dependencies.')
)


helps['extension remove'] = """
type: command
short-summary: {short}
examples:
  - name: {ex1}
    text: azdata extension remove --name some-ext
    crafted: true
""".format(
    short=_('Remove an extension.'),
    ex1=_('Remove an extension.')
)

helps['extension list'] = """
type: command
short-summary: {short}
examples:
  - name: {ex1}
    text: azdata extension list
""".format(
    short=_('List all installed extensions.'),
    ex1=_('List extensions.')
)
